﻿#region DEFINES
STATIC DEFINE MAILDLG_PBCANCEL := 101 
STATIC DEFINE MAILDLG_PBSEND := 102 
STATIC DEFINE MAILDLG_RICHEDIT1 := 100 
#endregion

class MailDlg inherit DIALOGWINDOW 

	protect oDCRichEdit1 as RICHEDIT
	protect oCCpbCancel as PUSHBUTTON
	protect oCCpbSend as PUSHBUTTON

  //{{%UC%}} USER CODE STARTS HERE (do NOT remove this line)

CONSTRUCTOR(oParent,uExtra)  

self:PreInit(oParent,uExtra)

LoadLibrary(String2Psz("RICHED32.DLL"))
SUPER(oParent,ResourceID{"MailDlg",_GetInst()},TRUE)

oDCRichEdit1 := RichEdit{self,ResourceID{MAILDLG_RICHEDIT1,_GetInst()}}
oDCRichEdit1:HyperLabel := HyperLabel{#RichEdit1,NULL_STRING,NULL_STRING,NULL_STRING}

oCCpbCancel := PushButton{self,ResourceID{MAILDLG_PBCANCEL,_GetInst()}}
oCCpbCancel:HyperLabel := HyperLabel{#pbCancel,"Cancel",NULL_STRING,NULL_STRING}

oCCpbSend := PushButton{self,ResourceID{MAILDLG_PBSEND,_GetInst()}}
oCCpbSend:HyperLabel := HyperLabel{#pbSend,"Send",NULL_STRING,NULL_STRING}

self:Caption := "Mail"
self:HyperLabel := HyperLabel{#MailDlg,"Mail",NULL_STRING,NULL_STRING}

self:PostInit(oParent,uExtra)

return self


METHOD pbCancel( ) 
	SELF:EndDialog()
RETURN SELF	

METHOD pbSend( ) 
	LOCAL cPlainText, cText, cPath, cFile AS STRING
	LOCAL oTB AS TextBox
		
	cPath 	:= 	cFile 	:= Space(260)
	cText 	:= oDCRichEdit1:Value
	cPlainText 	:= oDCRichEdit1:TextValue
	GetTempPath(256, PSZ(_CAST, cPath))
	GetTempFileName(PSZ(_CAST, cPath), PSZ(_CAST, "msg"), 0, PSZ(_CAST, cFile))
	
	cFile := StrTran(cFile, "TMP", "RTF")	

	IF SELF:QueryKey()
		MemoWrit(cFile, cText)	
 		DoSendMail (0, cFile, TRUE)
 	  ELSE
		oTB := TextBox{	SELF, "Error", "MS Exchange not installed ! " ;
						+ CHR(10) + "Do you want to save the mail to " + Trim(cFile) + " ?" }
		oTB:Type := BUTTONYESNO
		IF (oTB:Show() == BOXREPLYYES)
			MemoWrit(cFile, cText)	
	 	  ELSE
			DeleteFile(PSZ(_CAST, cPath))
 		ENDIF
	ENDIF
		
 	SELF:EndDialog()
RETURN SELF

METHOD PostInit() 
	oDCRichEdit1:SetFocus()		
RETURN SELF	

METHOD QueryKey() 
// 	This is a sample to get some info from the registry. In this case it looks
//	wether Microsoft Exchange is installed
	LOCAL lpSubKey AS PSZ
	LOCAL lpValue AS PSZ
	LOCAL lpValueName AS PSZ
	LOCAL lValue AS LONG
	LOCAL cData AS STRING
	LOCAL cbData AS DWORD
	LOCAL phkResult AS PTR
 	LOCAL liRes AS LONG
 	LOCAL lRet AS LOGIC

	cData      := Space(256)
	lValue      := 256
	lpValueName := PSZ(_CAST, Space(256))
	lpSubKey    := PSZ(_CAST, "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\MSExchng")
 	lpValue     := PSZ(_CAST, Space(256))

	liRes := RegOpenKey(HKEY_LOCAL_MACHINE, lpSubKey,	@phkResult)

	IF (liRes == ERROR_SUCCESS)
		cbData := 256	
		liRes  := RegQueryValueEx(phkResult , ;
								PSZ(_CAST, "UninstallString") , ; 	// Look for ValueName
								NULL_PTR , ;
								NULL_PTR , ;
								PSZ(_CAST, cData) , ;     	// Retrieve ValueData
								@cbData )
		
		IF (liRes == ERROR_SUCCESS)  .AND. ! Empty(cData)
			lRet := TRUE
		ENDIF	
											
  ENDIF

	RegCloseKey(HKEY_LOCAL_MACHINE)
	
	RETURN lRet


method Resize( oResizeEvent ) 
	local nHeight as int
	local nWidth  as int
	local sRect   is _WINRECT

	super:Resize( oResizeEvent )

	nWidth  := self:CanvasArea:Width
	nHeight := self:CanvasArea:Height
	GetWindowRect(self:handle(), @sRect)
	if nWidth < 200  .OR. nHeight < 200
		MoveWindow(self:handle(),  sRect.left, sRect.top, 400, 250, true)
		nWidth  := self:CanvasArea:Width
		nHeight := self:CanvasArea:Height
	endif	
	MoveWindow(oDCRichEdit1:Handle(), 30, 30, nWidth - 60, nHeight - 80, true)
	MoveWindow(oCCpbSend:Handle(), 30, nHeight - 40, 70, 25, true)
	MoveWindow(oCCpbCancel:Handle(), nWidth - 100, nHeight -  40,  70, 25, true)

  return nil



END CLASS
