#region DEFINES
STATIC DEFINE HELPABOUT_PUSHBUTTON1 := 104 
DEFINE IDI_STANDARDICON := 101
DEFINE IDS_ERROR := 65520
DEFINE IDS_EXCHANGE_NOT_INSTALLED := 65521
DEFINE IDS_SAVE := 65522
STATIC DEFINE MAILDLG_PBCANCEL := 101 
STATIC DEFINE MAILDLG_PBSEND := 102 
STATIC DEFINE MAILDLG_RICHEDIT1 := 100 
#endregion

CLASS StandardShellWindow INHERIT ShellWindow
	PROTECT oPrinter      AS PrintingDevice
	

METHOD DoOpenFile(cFileName, lReadOnly) 
	LOCAL oTB AS TextBox
	LOCAL oNewChild AS StdDataWindow

	IF (Len(cFileName) > 3 )  .AND. (Upper(Right(cFileName, 4)) == ".DBF")
		oNewChild := StdDataWindow{SELF, cFileName, lReadOnly}
	  oNewChild:ViewAs(#FormView)
  	oNewChild:Show()
	ELSE
		oTB := TextBox{SELF, "File Open Error", "Cannot open " + cFileName + " - Not a DBF file"}
		oTB:Type := BUTTONOKAY
		oTB:Show()
	ENDIF

RETURN SELF	

METHOD FileExit() 

	SELF:EndWindow()
	
RETURN SELF	


METHOD FileOpen() 
	LOCAL oOD AS OpenDialog

	(oOD := OpenDialog{SELF, "*.dbf"}):Show()
	
	IF !Empty(oOD:FileName)
		SELF:DoOpenFile(oOD:FileName, oOD:ReadOnly)
	ENDIF

RETURN SELF	

METHOD FilePrinterSetup() 

	oPrinter:Setup()
	
RETURN SELF	

CONSTRUCTOR( oOwnerApp ) 
	LOCAL oSB AS StatusBar
	
	SUPER( oOwnerApp )
	
	SetDeleted(TRUE)

#ifdef __APPWIZ__MODDRAGDROP	
  SELF:EnableDragDropClient()
#endif

	oSB := SELF:EnableStatusBar()
	oSB:DisplayTime()

	SELF:Menu := EmptyShellMenu{SELF}

	SELF:Icon 	:= Icon{ResourceID{IDI_STANDARDICON, _GetInst()}}
	SELF:IconSm := Icon{ResourceID{IDI_STANDARDICON, _GetInst()}}
	
	SELF:Caption := "Standard MDI Application"
	
	oPrinter := PrintingDevice{}
	
	RETURN SELF


ACCESS Printer 
	
	RETURN oPrinter


METHOD TestReport() 
	LOCAL oRpReport AS RpReport
	LOCAL cVorlage := "Vorlage01" AS STRING
	LOCAL aDbf AS ARRAY
	
	aDbf := {}
	SetDefault("..\..\applications\sedcardtest\resources\")
	AAdd(aDbf, {"DUMMY", GetDefault()+"DUMMY.DBF"})
	
	oRpReport := RpReport{SELF, GetDefault()+cVorlage+".RPT", GetDefault(), aDbf}
	IF oRpReport:IsValid
		oRpReport:PrinterDevice:Landscape := FALSE
		oRpReport:PrintPreview(cVorlage,cVorlage+".PRN",cVorlage,"Bericht in Bearbeitung...")
		oRpReport:Print(cVorlage,cVorlage+".PRN",cVorlage,"Bericht in Bearbeitung...")
	ENDIF
	oRpReport:Close()

RETURN SELF


METHOD WindowCascade() 

	SELF:Arrange(ARRANGECASCADE)

RETURN SELF

METHOD WindowIcon() 

	SELF:Arrange(ARRANGEASICONS)

RETURN SELF

METHOD WindowTile() 

	SELF:Arrange(ARRANGETILE)
	
RETURN SELF

END CLASS
CLASS StdDataWindow INHERIT DataWindow
	

METHOD FileClose() 

	SELF:Server:Close()

 	SELF:EndWindow()

RETURN SELF

METHOD FilePrint() 

	SELF:Print(SELF:Owner:Printer)

RETURN SELF	

CONSTRUCTOR(oParentWindow, sFileName, lReadOnly, oServer) 
	LOCAL sCaption AS STRING

	SUPER(oParentWindow)
	
	SELF:Menu := StandardShellMenu{SELF}
	SELF:ToolBar:PressItem(IDM_StandardShellMenu_View_Form_ID)
	sCaption  := "Browse Database: "

	IF !IsNil(oServer)
		SELF:Use(oServer)
		SELF:Caption := sCaption + oServer:Name
	ELSE
		SELF:Use(CreateInstance(#DBServer, sFileName, , lReadOnly))
		SELF:Caption := sCaption + sFileName
	ENDIF	

RETURN SELF

METHOD ViewForm() 
	SELF:ToolBar:UnPressItem(IDM_StandardShellMenu_View_Table_ID)
	SELF:ToolBar:PressItem(IDM_StandardShellMenu_View_Form_ID)
	
	RETURN SUPER:ViewForm()	




METHOD ViewTable() 
	SELF:ToolBar:UnPressItem(IDM_StandardShellMenu_View_Form_ID)
	SELF:ToolBar:PressItem(IDM_StandardShellMenu_View_Table_ID)
	
	RETURN SUPER:ViewTable()
	


END CLASS
